﻿package  {
	
	import flash.display.MovieClip;
	import flash.events.Event;
	import fl.controls.Button;
	
	public class EasingTools {
		
		public var theend:Function;

		public function EasingBrake(clip:MovieClip,posx:Number,posy:Number,friction:Number):void {
			var root = this;
			var pos_x = posx;
			var pos_y = posy;
			clip.addEventListener(Event.ENTER_FRAME,brake);
			function brake(e:Event){
				clip.x+= (pos_x - clip.x) * friction;
				clip.y+= (pos_y - clip.y) * friction;
				if(Math.round(clip.x) == Math.round(pos_x) && Math.round(clip.y) == Math.round(pos_y)){
					clip.removeEventListener(Event.ENTER_FRAME,brake);
					root.theend();
					
				}
			}
		}
		
		public function EasingElastic(clip:MovieClip,posx:Number,posy:Number,friction:Number,elasticity:Number):void {
			var root = this;
			var pos_x = posx;
			var pos_y = posy;
			var speedx = 0;
			var speedy = 0;
			clip.addEventListener(Event.ENTER_FRAME,moveelasticity);
			function moveelasticity(e:Event){
				speedx = (speedx * elasticity) + (pos_x - clip.x) * friction;
				clip.x+= speedx;
				speedy = (speedy * elasticity) + (pos_y - clip.y) * friction;
				clip.y+= speedy;
				if(Math.round(clip.x) == Math.round(pos_x) && Math.round(clip.y) == Math.round(pos_y) && Math.round(speedx) == 0 && Math.round(speedy) == 0){
					clip.x = pos_x;
					clip.y = pos_y;
					clip.removeEventListener(Event.ENTER_FRAME,moveelasticity);
					root.theend();
				}
			}
		}
		
		public function EasingInout(clip:MovieClip,px:Number,py:Number,a:Number):void{
			var root = this;
			var asc = a;
			var pinix = clip.x;
			var piniy = clip.y;
			var posx = px;
			var posy = py;
			
			var opuesto = posy - piniy;
			var adyacente = posx - pinix;
			var radianesini = Math.atan2(opuesto,adyacente);
			var distancia = Math.abs(adyacente / Math.cos(radianesini));
			
			clip.addEventListener(Event.ENTER_FRAME,moveBox);
			
			function moveBox(e:Event){
				//Calculos
				var opuestoactual = clip.y - piniy;
				var adyacenteactual = clip.x - pinix;
				var radianes = Math.atan2(opuestoactual,adyacenteactual);
				var posactual = Math.abs(adyacenteactual / Math.cos(radianes));
				if(posactual == 0){
					clip.x+= Math.cos(radianesini);
					clip.y+= Math.sin(radianesini);
				}else if(posactual < distancia/2){
					clip.x+= posactual* asc * Math.cos(radianesini);
					clip.y+= posactual * asc * Math.sin(radianesini);
				}else{
					clip.x+= (posx - clip.x) * asc;
					clip.y+= (posy - clip.y) * asc;
				}
				if(Math.round(clip.x) == posx && Math.round(clip.y) == posy) {
					clip.x = posx;
					clip.y = posy;
					clip.removeEventListener(Event.ENTER_FRAME,moveBox);
					root.theend();
				}
			}
			
		}
	}
}